#! /bin/bash

# runs several validation/test jobs on trained yolo models for various datasets, each pre-processed in a different way, but all including all 3 fish sources  
# NEW USERS will need to modify paths to data, model names, and all other azure configurations

SCRIPT="automated_jobs/run_job.py"
JOB="val"
EXP="experiment1-9"
TRAINDATA="azureml:Preprocess-fish-20perc-fishless:1"
BASE_DATA_DIR="data_preproc_full_exp"

#job for CLAHE then BS (did clahe first, then did BS on those CLAHE-ed images)
BASE_FOLDER_NAME_TRAIN="CLAHE_then_BS_train_20perc_fishless_2.0CL_15GS/"
BASE_FOLDER_NAME_VAL="CLAHE_then_BS_val_and_test_2.0CL_15GS/"
MODEL="azureml:exp1-9-clahe-then-bs-20perc-fishless-train-1-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-clahe-then-bs-20perc-fishless-test-1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"Igiugig_1" $BASE_FOLDER_NAME_TRAIN"Igiugig_2" $BASE_FOLDER_NAME_TRAIN"Igiugig_3" $BASE_FOLDER_NAME_TRAIN"Voith" $BASE_FOLDER_NAME_TRAIN"WellsDam" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc/test" $BASE_FOLDER_NAME_VAL"voith/test" $BASE_FOLDER_NAME_VAL"wells/test" \

#job for BS
BASE_FOLDER_NAME_TRAIN="BS_train_full_fish_plus20perc_fishless/"
BASE_FOLDER_NAME_VAL="BS_val_and_test/"
MODEL="azureml:exp1-9-clahe-then-bs-20perc-fishless-train-1-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-bs-20perc-fishless-test-1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"Igiugig_1" $BASE_FOLDER_NAME_TRAIN"Igiugig_2" $BASE_FOLDER_NAME_TRAIN"Igiugig_3" $BASE_FOLDER_NAME_TRAIN"Voith" $BASE_FOLDER_NAME_TRAIN"WellsDam" \
    --val-dirs $BASE_FOLDER_NAME_VAL"test/orpc" $BASE_FOLDER_NAME_VAL"test/voith" $BASE_FOLDER_NAME_VAL"test/wells" \

#job for BS then CLAHE
BASE_FOLDER_NAME_TRAIN="BS_then_CLAHE_train_CL2.0_GS15/"
BASE_FOLDER_NAME_VAL="BS_then_CLAHE_val_and_test_CL2.0_grid_size15/"
MODEL="azureml:exp1-9-bs-then-clahe-20perc-fishless-test-1-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-bs-then-clahe-20perc-fishless-test-1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"Igiugig_1" $BASE_FOLDER_NAME_TRAIN"Igiugig_2" $BASE_FOLDER_NAME_TRAIN"Igiugig_3" $BASE_FOLDER_NAME_TRAIN"Voith" $BASE_FOLDER_NAME_TRAIN"WellsDam" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc/test" $BASE_FOLDER_NAME_VAL"voith/test" $BASE_FOLDER_NAME_VAL"wells/test" \
#job for baseline which should be no preprocessing
TRAINDATA="azureml:duplicates-removed-justfish-and-20perc-fishless:1"
BASE_DATA_DIR="data"
BASE_FOLDER_NAME_TRAIN="train_files_20perc_fishless_rmv_dup/"
BASE_FOLDER_NAME_VAL="val_and_test_files_dup_rmv/"
MODEL="azureml:exp1-6-20percfishless-de-dup-v8m-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-baseline-nopreproc-20perc-fishless-test-1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"Igiugig_1" $BASE_FOLDER_NAME_TRAIN"Igiugig_2" $BASE_FOLDER_NAME_TRAIN"Igiugig_3" $BASE_FOLDER_NAME_TRAIN"Voith" $BASE_FOLDER_NAME_TRAIN"WellsDam" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc/test" $BASE_FOLDER_NAME_VAL"voith/test" $BASE_FOLDER_NAME_VAL"wells/test" \
