#! /bin/bash

# runs several validation jobs on trained yolo models for various datasets, each pre-processed in a different way, but all including all 3 fish sources  
# NEW USERS will need to modify paths to data, model names, and all other azure configurations

SCRIPT="automated_jobs/run_job.py"
JOB="val"
EXP="experiment1-9" #even though this says experiment1.9, this is experiment 3 from the paper
TRAINDATA="azureml:exp3-BS-CLAHE-combos:1"
BASE_DATA_DIR="data_exp3"


#job BS
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS/"
MODEL="azureml:exp1-9-1_bs_separated-try2-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-1_BS_separated-val \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"orpc1/fish" $BASE_FOLDER_NAME_TRAIN"orpc1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc2/fish" $BASE_FOLDER_NAME_TRAIN"orpc2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc3/fish" $BASE_FOLDER_NAME_TRAIN"orpc3/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"wells1/fish" $BASE_FOLDER_NAME_TRAIN"wells1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc5/fish" $BASE_FOLDER_NAME_VAL"orpc5/fishless_20percent" $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" $BASE_FOLDER_NAME_VAL"wells2/fish" \

#job for BS_then_clahe
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS_then_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS_then_CLAHE/"
MODEL="azureml:exp1-9-1_bs_then_clahe_separated-try2-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-1_BS_then_CLAHE_separated-val \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"orpc1/fish" $BASE_FOLDER_NAME_TRAIN"orpc1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc2/fish" $BASE_FOLDER_NAME_TRAIN"orpc2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc3/fish" $BASE_FOLDER_NAME_TRAIN"orpc3/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"wells1/fish" $BASE_FOLDER_NAME_TRAIN"wells1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc5/fish" $BASE_FOLDER_NAME_VAL"orpc5/fishless_20percent" $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" $BASE_FOLDER_NAME_VAL"wells2/fish" \

#job for CLAHE then BS
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE_then_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE_then_BS/"
MODEL="azureml:exp1-9-1_clahe_then_bs_separated-try2-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-1_CLAHE_then_BS_separated-val \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"orpc1/fish" $BASE_FOLDER_NAME_TRAIN"orpc1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc2/fish" $BASE_FOLDER_NAME_TRAIN"orpc2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc3/fish" $BASE_FOLDER_NAME_TRAIN"orpc3/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"wells1/fish" $BASE_FOLDER_NAME_TRAIN"wells1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc5/fish" $BASE_FOLDER_NAME_VAL"orpc5/fishless_20percent" $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" $BASE_FOLDER_NAME_VAL"wells2/fish" \

#job CLAHE
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE/"
MODEL="azureml:exp1-9-1_clahe_separated-try2-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-1_CLAHE_separated-val \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"orpc1/fish" $BASE_FOLDER_NAME_TRAIN"orpc1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc2/fish" $BASE_FOLDER_NAME_TRAIN"orpc2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc3/fish" $BASE_FOLDER_NAME_TRAIN"orpc3/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"wells1/fish" $BASE_FOLDER_NAME_TRAIN"wells1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc5/fish" $BASE_FOLDER_NAME_VAL"orpc5/fishless_20percent" $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" $BASE_FOLDER_NAME_VAL"wells2/fish" \

#job for baseline which should be no preprocessing
BASE_FOLDER_NAME_TRAIN="data_div_subfolders/"
BASE_FOLDER_NAME_VAL="data_div_subfolders/"
MODEL="azureml:exp1-9-1_base_separated_best:1" ####CHANGE based on what is the best model
python3 $SCRIPT \
    --job $JOB \
    --job-name exp1-9-1_base_separated-val \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"orpc1/fish" $BASE_FOLDER_NAME_TRAIN"orpc1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc2/fish" $BASE_FOLDER_NAME_TRAIN"orpc2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"orpc3/fish" $BASE_FOLDER_NAME_TRAIN"orpc3/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"wells1/fish" $BASE_FOLDER_NAME_TRAIN"wells1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"orpc5/fish" $BASE_FOLDER_NAME_VAL"orpc5/fishless_20percent" $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" $BASE_FOLDER_NAME_VAL"wells2/fish" \

