#! /bin/bash

# Runs the azure ML jobs for validating the YOLO models that were trained using just Voith image data
# each job is run using different pre-processed versions of the same data
#as specified by their names

#NEW USER: customize script, train data, base folder and data directory names, and models


SCRIPT="automated_jobs/run_job.py"
JOB="val"
EXP="experiment3-0-3"
TRAINDATA="azureml:exp3-BS-CLAHE-combos:1"
BASE_DATA_DIR="data_exp3"

#job BS (background subtraction)
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS/"
MODEL="azureml:exp3-0-3_bs-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_BS-val1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" \

#job for BS_then_clahe
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS_then_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS_then_CLAHE/"
MODEL="azureml:exp3-0-3_bs_then_clahe-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_BS_then_CLAHE-val1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" \

#job for CLAHE then BS
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE_then_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE_then_BS/"
MODEL="azureml:exp3-0-3_clahe_then_bs-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_CLAHE_then_BS-val1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" \

#job CLAHE
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE/"
MODEL="azureml:exp3-0-3_clahe-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_CLAHE-val1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" \

#job for baseline which should be no preprocessing
BASE_FOLDER_NAME_TRAIN="data_div_subfolders/"
BASE_FOLDER_NAME_VAL="data_div_subfolders/"
MODEL="azureml:exp3-0-3_base_no_preproc-best:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_base_no_preproc-val1 \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith3/fish" $BASE_FOLDER_NAME_VAL"voith3/fishless_20percent" \


