#! /bin/bash

# Runs the azure ML jobs for training YOLO models using just Voith image data
# each job is run using different pre-processed versions of the same data
# as specified by their names

#NEW USER: customize script, train data, base folder and data directory names, and models


SCRIPT="automated_jobs/run_job.py"
JOB="train"
EXP="experiment3-0-3"
TRAINDATA="azureml:exp3-BS-CLAHE-combos:1"
BASE_DATA_DIR="data_exp3"

#job BS
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS/"
MODEL="azureml:yolov8m-vas:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_BS \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith2/fish" $BASE_FOLDER_NAME_VAL"voith2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith4/fish" $BASE_FOLDER_NAME_TRAIN"voith4/fishless_20percent" \

#job for BS_then_clahe
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_BS_then_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_BS_then_CLAHE/"
MODEL="azureml:yolov8m-vas:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_BS_then_CLAHE \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith2/fish" $BASE_FOLDER_NAME_VAL"voith2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith4/fish" $BASE_FOLDER_NAME_TRAIN"voith4/fishless_20percent" \

#job for CLAHE then BS
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE_then_BS/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE_then_BS/"
MODEL="azureml:yolov8m-vas:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_CLAHE_then_BS \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith2/fish" $BASE_FOLDER_NAME_VAL"voith2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith4/fish" $BASE_FOLDER_NAME_TRAIN"voith4/fishless_20percent" \

#job CLAHE
BASE_FOLDER_NAME_TRAIN="data_div_subfolders_CLAHE/"
BASE_FOLDER_NAME_VAL="data_div_subfolders_CLAHE/"
MODEL="azureml:yolov8m-vas:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_CLAHE \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --epochs 50 \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith2/fish" $BASE_FOLDER_NAME_VAL"voith2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith4/fish" $BASE_FOLDER_NAME_TRAIN"voith4/fishless_20percent" \

#job for baseline which should be no preprocessing
BASE_FOLDER_NAME_TRAIN="data_div_subfolders/"
BASE_FOLDER_NAME_VAL="data_div_subfolders/"
MODEL="azureml:yolov8m-vas:1"
python3 $SCRIPT \
    --job $JOB \
    --job-name exp3-0-3_base_no_preproc \
    --exp-name $EXP \
    --train-data $TRAINDATA \
    --pre-model $MODEL \
    --base-data-dir $BASE_DATA_DIR \
    --train-dirs $BASE_FOLDER_NAME_TRAIN"voith1/fish" $BASE_FOLDER_NAME_TRAIN"voith1/fishless_20percent" \
    --val-dirs $BASE_FOLDER_NAME_VAL"voith2/fish" $BASE_FOLDER_NAME_VAL"voith2/fishless_20percent" $BASE_FOLDER_NAME_TRAIN"voith4/fish" $BASE_FOLDER_NAME_TRAIN"voith4/fishless_20percent" \