import numpy as np

def compute_image_difference(img1, img2):
    """Returns an image that represents the difference between two images.

    Args:
        img1 (numpy.ndarray): First image.
        img2 (numpy.ndarray): Second image.

    Returns:
        numpy.ndarray: Difference between images.
    """
    assert img1.shape == img2.shape, "Image dimensions don't match."
    diff = np.abs(img1.astype(np.int16) - img2.astype(np.int16))
    return np.clip(diff, 0, 255).astype(np.uint8)