#! /bin/bash

#first, take the test y files and convert them to txt files (they are currently xmls)
#this link has to be in wherever they are located in downloads

test_x_input_start="/Users/victoriasabo/Documents/WPTO/Data"
test_y_input_end="_test_y"
test_fish_sources=('wells' 'voith' 'orpc')
out_dir_tests="/Users/victoriasabo/Documents/eyesea-yolo/scripts/data/testing_files"

for f_source in "${test_fish_sources[@]}"
do
    in_dir_full=$test_x_input_start"/"$f_source$test_y_input_end
    out_dir_full=$out_dir_tests"/"$f_source"/labels"
    python3 scripts/data_processing_scripts/WPTO_convert_py.py $in_dir_full $out_dir_full
done

#now move the test_x files to the respective folders as well
test_x_input_end="_test_x"
for f_source in "${test_fish_sources[@]}"
do
    #we want to have the test_x folders just moved to the given output file
    current_dir_full=$test_x_input_start"/"$f_source$test_x_input_end
    out_dir_full=$out_dir_tests"/"$f_source"/images"
    mv $current_dir_full $out_dir_full
done

#split the train_x into several different groups
#but this will delete those 2 train_x and train_y, so we want to make sure they are a copy if we don't want that deleted
#you need to have train_x and train_y in a folder at the 'in_directory' address
dataset_parent_directory="/Users/victoriasabo/Documents/eyesea-yolo/scripts"
data_folder_name="data"
in_directory="/Users/victoriasabo/Documents/eyesea-yolo/scripts/data/train_and_val_files"

python3 scripts/data_processing_scripts/split_datasets_by_source_Ig.py $dataset_parent_directory $data_folder_name $in_directory

#this will create an entire folder of 5 sub-folders, each with 'images' and 'labels' subfolders
#it will also make sure each of those sub folders is empty to begin with, so no files are saved more than once
#then it will delete the original train_x and train_y to save space

#then you take each of those and convert the labels to txt, then split images into fish and no fish
list_fish_sources=('Igiugig_1' 'Igiugig_2' 'Igiugig_3' 'Voith' 'WellsDam')

for fish_source in "${list_fish_sources[@]}"
do
    in_dir_lab=$in_directory"/"$fish_source"/labels_first_iter"
    in_dir_im=$in_directory"/"$fish_source"/images_first_iter"
    txt_file_loc=$in_directory"/"$fish_source"/labels_"
    out_dir_im=$in_directory"/"$fish_source"/images_"
    python3 scripts/data_processing_scripts/convert_txt_and_split_fish.py $in_dir_lab $in_dir_im $txt_file_loc $out_dir_im
done

#then you have to take each of the images and labels folders of fish and split into train and val
ratio_per_val=0.2
in_image_folder_name="images_/fish"
in_label_folder_name="labels_"
out_image_folder_name="images"
out_label_folder_name="labels"

list_fish_sources_noig3=('Igiugig_1' 'Igiugig_2' 'Voith' 'WellsDam')

for fish_source in "${list_fish_sources_noig3[@]}"
do
    python3 scripts/data_processing_scripts/split_train_val.py $in_directory $in_image_folder_name $in_label_folder_name $out_image_folder_name $out_label_folder_name $in_directory $fish_source $ratio_per_val
done

#now do igiguigg 3 separately because it have only 30 images with fish so the ratio has to be lower to capture it
fish_source="Igiugig_3"
ratio_per_val=0.08
python3 scripts/data_processing_scripts/split_train_val.py $in_directory $in_image_folder_name $in_label_folder_name $out_image_folder_name $out_label_folder_name $in_directory $fish_source $ratio_per_val
