#! /bin/bash


#first we are going to have to change xml to txt (because the way we split val and test require this)

test_y_input_start="/Users/victoriasabo/Documents/WPTO/Data"
list_fish_sources_tests=('orpc' 'wells' 'voith')
test_y_input_end="_test_y"


for f_source in "${list_fish_sources_tests[@]}"
do
    
    in_dir_full=$test_y_input_start"/"$f_source$test_y_input_end
    echo "$in_dir_full"
    out_dir_full=$test_y_input_start"/"$f_source"_test_y_txt"
    #these will then take the xmls in _test_y folder, convert to txts in the _test_y_txt folder, and delete _test_y folder
    python3 scripts/data_processing_scripts/WPTO_convert_py_article.py $in_dir_full $out_dir_full
done

#now, we need to split the test files into 10% val and remainder test,
# making sure not to split at an area where there exists a fish to be tracked

ratio_per_val=0.1
in_files_base="/Users/victoriasabo/Documents/WPTO/Data"
in_image_folder_extention="_test_x"
in_label_folder_extension="_test_y_txt"
out_image_folder_name="images"
out_label_folder_name="labels"
out_files_base="/Users/victoriasabo/Documents/eyesea-yolo/scripts/data/val_and_test_files"


for fish_source in "${list_fish_sources_tests[@]}"
do
    in_image_folder_name=$fish_source$in_image_folder_extention
    in_label_folder_name=$fish_source$in_label_folder_extension
    python3 scripts/data_processing_scripts/split_test_val.py $in_files_base $in_image_folder_name $in_label_folder_name $out_image_folder_name $out_label_folder_name $out_files_base $fish_source $ratio_per_val
done

#this will create 3 folders in a larger val_and_test_files folder
#each with test and val sub-folders, each of those which have 'images' and 'labels' folders


#Now address the train_x into the different sources
#This will divide train_x and train_y into their separate sources and then delete them,
#so we need to make sure there is another copy if we don't want that deleted permanently
#to start this, you need to have train_x and train_y in a folder at the 'dataset_parent_directory/data_folder_name' address
dataset_parent_directory="/Users/victoriasabo/Documents/WPTO"
data_folder_name="Data"
out_directory="/Users/victoriasabo/Documents/eyesea-yolo/scripts/data/train_files"

python3 scripts/data_processing_scripts/split_datasets_by_source_Ig_article.py $dataset_parent_directory $data_folder_name $out_directory

#this will create a new folder train_files with 5 sub-folders, one for each source (Ig has 3 diff camera angles
#Each of these 5 sub-folders will have an 'images_first_iter' and 'labels_first_iter' subfolders
#it will also make sure each of those sub folders is empty to begin with, so no files are saved more than once
#then it will delete the original train_x and train_y to save space

#then you take each of those 'labels_first_iter' labels, convert them to txts in just a 'labels' folder, and then
#split images into fish and no fish and just output the fish images into a folder called 'images'
list_fish_sources=('Igiugig_1' 'Igiugig_2' 'Igiugig_3' 'Voith' 'WellsDam')

for fish_source in "${list_fish_sources[@]}"
do
    in_dir_lab=$out_directory"/"$fish_source"/labels_first_iter"
    in_dir_im=$out_directory"/"$fish_source"/images_first_iter"
    txt_file_loc=$out_directory"/"$fish_source"/labels"
    out_dir_im=$out_directory"/"$fish_source"/images"
    python3 scripts/data_processing_scripts/convert_txt_and_split_fish_article.py $in_dir_lab $in_dir_im $txt_file_loc $out_dir_im
done


#we will then move a couple of files from test_and_val orpc
#because there are no fish frames in val as it stands
#we will move 6 of the test fish images with labels to val so that val has some fish labels
list_fish_images=('210' '211' '212' '238' '273' '274') #the 'number image' at the end of 6 different image file names which we are selcting to move
base_name_fish_iamges="orpc_adults_then_smolt_fm_"

for fish_image_num in "${list_fish_images[@]}"
do
    full_image_name=$base_name_fish_iamges$fish_image_num".png"
    full_label_name=$base_name_fish_iamges$fish_image_num".txt"
    starting_location_base="scripts/data/val_and_test_files/orpc/test"
    echo "moving this file "$full_image_name" from test/images to val/images"
    echo "moving this file "$full_label_name" from test/labels to val/labels"
    mv scripts/data/val_and_test_files/orpc/test/images/$full_image_name scripts/data/val_and_test_files/orpc/val/images/$full_image_name
    mv scripts/data/val_and_test_files/orpc/test/labels/$full_label_name scripts/data/val_and_test_files/orpc/val/labels/$full_label_name
done

